Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/attribute.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/attribute.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/attribute.f90	(revision 5600)
@@ -619,5 +742,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(sd_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -625,5 +748,9 @@
       att__init_i2%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i2%i_type=NF90_SHORT
+      IF( PRESENT(id_type) )THEN
+         att__init_i2%i_type=id_type
+      ELSE
+         att__init_i2%i_type=NF90_SHORT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i2%d_value) )THEN
@@ -636,22 +763,24 @@
 
    END FUNCTION att__init_i2
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
-   !> integer(2) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] sd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
+   !> integer(2) value. 
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] sd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i2_0d( cd_name, sd_value )
+   TYPE(TATT) FUNCTION att__init_i2_0d( cd_name, sd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       INTEGER(i2),      INTENT(IN) :: sd_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       !local value
@@ -664,5 +793,5 @@
       cl_value="(/"//TRIM(fct_str(sd_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attibute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -670,5 +799,9 @@
       att__init_i2_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i2_0d%i_type=NF90_SHORT
+      IF( PRESENT(id_type) )THEN
+         att__init_i2_0d%i_type=id_type
+      ELSE
+         att__init_i2_0d%i_type=NF90_SHORT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i2_0d%d_value) )THEN
@@ -681,22 +814,24 @@
 
    END FUNCTION att__init_i2_0d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of integer(4) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] id_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of integer(4) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] id_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i4( cd_name, id_value )
+   TYPE(TATT) FUNCTION att__init_i4( cd_name, id_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       INTEGER(i4),      DIMENSION(:), INTENT(IN) :: id_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -711,5 +846,5 @@
       CALL att_clean(att__init_i4)
       
-      ! table size
+      ! array size
       il_len=size(id_value(:))
 
@@ -720,5 +855,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(id_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -726,5 +861,9 @@
       att__init_i4%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i4%i_type=NF90_INT
+      IF( PRESENT(id_type) )THEN
+         att__init_i4%i_type=id_type
+      ELSE
+         att__init_i4%i_type=NF90_INT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i4%d_value) )THEN
@@ -737,22 +876,24 @@
 
    END FUNCTION att__init_i4
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
-   !> integer(4) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] id_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
+   !> integer(4) value. 
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !>
+   !> @param[in] cd_name   attribute name
+   !> @param[in] id_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i4_0d( cd_name, id_value )
+   TYPE(TATT) FUNCTION att__init_i4_0d( cd_name, id_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       INTEGER(i4),      INTENT(IN) :: id_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       !local value
@@ -765,5 +906,5 @@
       cl_value="(/"//TRIM(fct_str(id_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attibute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -771,5 +912,9 @@
       att__init_i4_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i4_0d%i_type=NF90_INT
+      IF( PRESENT(id_type) )THEN
+         att__init_i4_0d%i_type=id_type
+      ELSE
+         att__init_i4_0d%i_type=NF90_INT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i4_0d%d_value) )THEN
@@ -782,22 +927,24 @@
 
    END FUNCTION att__init_i4_0d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of integer(8) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] kd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of integer(8) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] kd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i8( cd_name, kd_value )
+   TYPE(TATT) FUNCTION att__init_i8( cd_name, kd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       INTEGER(i8),      DIMENSION(:), INTENT(IN) :: kd_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -812,5 +959,5 @@
       CALL att_clean(att__init_i8)
       
-      ! table size
+      ! array size
       il_len=size(kd_value(:))
 
@@ -821,5 +968,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(kd_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attibute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -827,5 +974,9 @@
       att__init_i8%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i8%i_type=NF90_INT
+      IF( PRESENT(id_type) )THEN
+         att__init_i8%i_type=id_type
+      ELSE
+         att__init_i8%i_type=NF90_INT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i8%d_value) )THEN
@@ -838,22 +989,24 @@
 
    END FUNCTION att__init_i8
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
-   !> integer(8) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] kd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
+   !> integer(8) value. 
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] kd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i8_0d( cd_name, kd_value )
+   TYPE(TATT) FUNCTION att__init_i8_0d( cd_name, kd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       INTEGER(i8),      INTENT(IN) :: kd_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -866,5 +1019,5 @@
       cl_value="(/"//TRIM(fct_str(kd_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attibute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -872,5 +1025,9 @@
       att__init_i8_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i8_0d%i_type=NF90_INT
+      IF( PRESENT(id_type) )THEN
+         att__init_i8_0d%i_type=id_type
+      ELSE
+         att__init_i8_0d%i_type=NF90_INT
+      ENDIF
 
       IF( ASSOCIATED(att__init_i8_0d%d_value) )THEN
@@ -883,15 +1040,37 @@
 
    END FUNCTION att__init_i8_0d
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine print attribute information
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_att : attribute structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE att_print(td_att)
+   !-------------------------------------------------------------------
+   !> @brief This subroutine print informations of an array of attribute. 
+   !>
+   !> @author J.Paul
+   !> @date June, 2014 - Initial Version
+   !>
+   !> @param[in] td_att array of attribute structure
+   !-------------------------------------------------------------------
+   SUBROUTINE att__print_arr(td_att)
+      IMPLICIT NONE
+
+      ! Argument      
+      TYPE(TATT), DIMENSION(:), INTENT(IN) :: td_att
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=1,SIZE(td_att(:))
+         CALL att_print(td_att(ji))
+      ENDDO
+
+   END SUBROUTINE att__print_arr
+   !-------------------------------------------------------------------
+   !> @brief This subroutine print attribute information.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date September, 2014 - take into account type of attribute.
+   !
+   !> @param[in] td_att attribute structure
+   !-------------------------------------------------------------------
+   SUBROUTINE att__print_unit(td_att)
       IMPLICIT NONE
 
@@ -902,5 +1081,10 @@
       CHARACTER(LEN=lc) :: cl_type
       CHARACTER(LEN=lc) :: cl_value
-      CHARACTER(LEN=lc) :: cl_tmp
+
+      INTEGER(i8)       :: kl_tmp
+      INTEGER(i2)       :: sl_tmp
+      INTEGER(i1)       :: bl_tmp
+      REAL(sp)          :: rl_tmp
+      REAL(dp)          :: dl_tmp
 
       ! loop indices
@@ -924,5 +1108,5 @@
             CASE DEFAULT
                cl_type=''
-               !cl_type='unknown'
+
          END SELECT
 
@@ -932,21 +1116,69 @@
                cl_value=td_att%c_value
 
-            CASE(NF90_BYTE, NF90_SHORT, NF90_INT, NF90_FLOAT, NF90_DOUBLE)   
+            CASE(NF90_BYTE)   
                IF( td_att%i_len > 1 )THEN
-
-                  cl_tmp=','
                   cl_value='(/'
                   DO ji=1,td_att%i_len-1
-                     cl_value=TRIM(cl_value)//&
-                     &        TRIM(fct_str(td_att%d_value(ji)))//TRIM(cl_tmp)
+                     bl_tmp=INT(td_att%d_value(ji),i1)
+                     cl_value=TRIM(cl_value)//TRIM(fct_str(bl_tmp))//','
                   ENDDO
-                  cl_value=TRIM(cl_value)//&
-                  &        TRIM(fct_str(td_att%d_value(td_att%i_len)))//'/)'
-
+                  bl_tmp=INT(td_att%d_value(td_att%i_len),i1)
+                  cl_value=TRIM(cl_value)//TRIM(fct_str(bl_tmp))//'/)'
                ELSE
-
                   cl_value='(/'//TRIM(fct_str(td_att%d_value(1)))//'/)'
-
                ENDIF
+
+            CASE(NF90_SHORT)   
+               IF( td_att%i_len > 1 )THEN
+                  cl_value='(/'
+                  DO ji=1,td_att%i_len-1
+                     sl_tmp=INT(td_att%d_value(ji),i2)
+                     cl_value=TRIM(cl_value)//TRIM(fct_str(sl_tmp))//','
+                  ENDDO
+                  sl_tmp=INT(td_att%d_value(td_att%i_len),i2)
+                  cl_value=TRIM(cl_value)//TRIM(fct_str(sl_tmp))//'/)'
+               ELSE
+                  cl_value='(/'//TRIM(fct_str(td_att%d_value(1)))//'/)'
+               ENDIF
+
+            CASE(NF90_INT)   
+               IF( td_att%i_len > 1 )THEN
+                  cl_value='(/'
+                  DO ji=1,td_att%i_len-1
+                     kl_tmp=INT(td_att%d_value(ji),i8)
+                     cl_value=TRIM(cl_value)//TRIM(fct_str(kl_tmp))//','
+                  ENDDO
+                  kl_tmp=INT(td_att%d_value(td_att%i_len),i8)
+                  cl_value=TRIM(cl_value)//TRIM(fct_str(kl_tmp))//'/)'
+               ELSE
+                  cl_value='(/'//TRIM(fct_str(td_att%d_value(1)))//'/)'
+               ENDIF
+
+            CASE(NF90_FLOAT)   
+               IF( td_att%i_len > 1 )THEN
+                  cl_value='(/'
+                  DO ji=1,td_att%i_len-1
+                     rl_tmp=REAL(td_att%d_value(ji),sp)
+                     cl_value=TRIM(cl_value)//TRIM(fct_str(rl_tmp))//','
+                  ENDDO
+                  rl_tmp=REAL(td_att%d_value(td_att%i_len),sp)
+                  cl_value=TRIM(cl_value)//TRIM(fct_str(rl_tmp))//'/)'
+               ELSE
+                  cl_value='(/'//TRIM(fct_str(td_att%d_value(1)))//'/)'
+               ENDIF
+
+            CASE(NF90_DOUBLE)   
+               IF( td_att%i_len > 1 )THEN
+                  cl_value='(/'
+                  DO ji=1,td_att%i_len-1
+                     dl_tmp=REAL(td_att%d_value(ji),dp)
+                     cl_value=TRIM(cl_value)//TRIM(fct_str(dl_tmp))//','
+                  ENDDO
+                  dl_tmp=REAL(td_att%d_value(td_att%i_len),dp)
+                  cl_value=TRIM(cl_value)//TRIM(fct_str(dl_tmp))//'/)'
+               ELSE
+                  cl_value='(/'//TRIM(fct_str(td_att%d_value(1)))//'/)'
+               ENDIF
+
             CASE DEFAULT
                cl_value="none"
@@ -960,6 +1192,5 @@
          &        " value : ",TRIM(ADJUSTL(cl_value))
 
-   END SUBROUTINE att_print
-   !> @endcode
+   END SUBROUTINE att__print_unit
    !-------------------------------------------------------------------
    !> @brief 
@@ -967,10 +1198,9 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_att : attribute strcuture
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE att_clean( td_att )
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[inout] td_att attribute strcuture
+   !-------------------------------------------------------------------
+   SUBROUTINE att__clean_unit( td_att )
       IMPLICIT NONE
       ! Argument
@@ -981,5 +1211,5 @@
       !----------------------------------------------------------------
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " CLEAN: reset attribute "//TRIM(td_att%c_name) )
 
@@ -990,8 +1220,31 @@
 
       ! replace by empty structure
-      td_att=tl_att
-
-   END SUBROUTINE att_clean
-   !> @endcode
+      td_att=att_copy(tl_att)
+
+   END SUBROUTINE att__clean_unit
+   !-------------------------------------------------------------------
+   !> @brief 
+   !>  This subroutine clean array of attribute strcuture.
+   !
+   !> @author J.Paul
+   !> @date September, 2014 - Initial Version
+   !
+   !> @param[inout] td_att attribute strcuture
+   !-------------------------------------------------------------------
+   SUBROUTINE att__clean_arr( td_att )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TATT), DIMENSION(:), INTENT(INOUT) :: td_att
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=SIZE(td_att(:)),1,-1
+         CALL att_clean(td_att(ji) )
+      ENDDO
+
+   END SUBROUTINE att__clean_arr
 END MODULE att
 
